<?php

namespace App\Wrangler\Components;

use Illuminate\Http\Request;
use Medialight\Textstem\Helpers\MediaAsset;
use Medialight\Textstem\Models\WranglerPage;
use Medialight\Textstem\Wrangler\ActiveComponent;

class Image extends ActiveComponent
{
    public $config;

    public $editSetup = [
        [
            'name' => 'template',
            'controltype' => 'select-template',
            'value' => 'default',
            'label' => 'View template',

        ],
        [
            'name' => 'title',
            'controltype' => 'text',
            'value' => '',
            'label' => 'Title',
            'instructions' => 'Optional title. Note - this text will be escaped. To enter raw HTML, use the HTML block.',
        ],
        [
            'name' => 'content',
            'controltype' => 'image',
            'value' => '',
            'label' => 'Content',

        ],

    ];

    public function __construct($instance)
    {
        parent::__construct($instance);
        $this->config['asset'] = MediaAsset::loadForPath($this->config['content'] ?? '');
    }

    public function render(Request $request, WranglerPage $wranglerPage)
    {
        $view = $this->getView();

        return view($view, $this->config)->render();
    }

    public function preview()
    {
        $view = $this->getView();

        return view($view, $this->config)->render();
    }
}
